package org.apache.commons.lang3.time;

package .tmp;

import java.io.IOException;
import java.util.Calendar;
import org.apache.commons.lang3.time.FastDatePrinter;

class TimeZoneNumberRule implements FastDatePrinter.Rule {
  static final TimeZoneNumberRule INSTANCE_COLON = new TimeZoneNumberRule(true);
  
  static final TimeZoneNumberRule INSTANCE_NO_COLON = new TimeZoneNumberRule(false);
  
  final boolean mColon;
  
  TimeZoneNumberRule(boolean colon) {
    this.mColon = colon;
  }
  
  public int estimateLength() {
    return 5;
  }
  
  public void appendTo(Appendable buffer, Calendar calendar) throws IOException {
    int offset = calendar.get(15) + calendar.get(16);
    if (offset < 0) {
      buffer.append('-');
      offset = -offset;
    } else {
      buffer.append('+');
    } 
    int hours = offset / 3600000;
    FastDatePrinter.access$000(buffer, hours);
    if (this.mColon)
      buffer.append(':'); 
    int minutes = offset / 60000 - 60 * hours;
    FastDatePrinter.access$000(buffer, minutes);
  }
}
